<script>
import colors from "../../../scss/colors.scss";
import Chart from "chart.js/auto";

export default {
  name: "ProceedingStatisticsProceedingsByTopics",
  data () {
    // do not put this inside the return-statement (https://stackoverflow.com/a/68606394), 19.10.2022 Christa Becker
    this.drawnChart = null;
    return {
      displayType: "charts",
      chartOptions: {
        type: "bar",
        options: {
          maintainAspectRatio: false,
          responsive: true,
          indexAxis: "y",
          elements: {
            bar: {
              borderWidth: 0
            }
          },
          scales: {
            x: {
              display: true,
              ticks: {
                stepsize: 10
              },
              stacked: true
            },
            y: {
              beginAtZero: true,
              stacked: true,
              ticks: {
                autoSkip: false
              }
            }
          },
          plugins: {
            legend: {
              display: false
            }
          }
        }
      }
    };
  },
  computed: {
    proceedingsByTopics () {
      return this.$store.getters.proceedingsByTopics;
    },
    maximumTopicCount () {
      return this.proceedingsByTopics && this.proceedingsByTopics.length
        ? this.proceedingsByTopics[0].count
        : 0;
    },
    formattedChartData () {
      return {
        options: {
          scales: {
            x: {
              ticks: {
                stepSize: this.xScaleTickStepSize
              }
            }
          }
        },
        data: {
          labels: this.proceedingsByTopics.map(item => item.topic),
          datasets: [
            {
              data: this.proceedingsByTopics.map(item => item.count),
              backgroundColor: colors.color_diagram_02,
              barThickness: 15,
              minBarLength: 1,
              showThisTooltip: true
            },
            {
              data: this.proceedingsByTopics.map((elem) => this.xScaleWidth - elem.count),
              backgroundColor: "rgba(" + Object.values(this.$hex2rgb(colors.color_diagram_02)).join(", ") + ", 0.15)",
              barThickness: 15,
              showThisTooltip: false
            }
          ]
        }
      };
    },
    xScaleTickStepSize () {
      return this.proceedingsByTopics && this.proceedingsByTopics.length
        ? Math.pow(10, this.proceedingsByTopics[0].count.toString().length - 1)
        : 0;
    },
    xScaleWidth () {
      return Math.ceil(this.maximumTopicCount * 1.1);
    }
  },
  watch: {
    formattedChartData: {
      deep: true,
      handler () {
        this.initChart();
      }
    }
  },
  mounted () {
    this.initChart();
  },
  methods: {
    initChart () {
      if (this.proceedingsByTopics.length) {
        if (this.drawnChart) {
          this.drawnChart.options = this.$mergeDeep(this.chartOptions.options, this.formattedChartData.options);
          this.drawnChart.data = this.formattedChartData.data;
        }
        else {
          this.drawnChart = new Chart(
            this.$refs.chart.getContext("2d"),
            JSON.parse(JSON.stringify(this.$mergeDeep(this.chartOptions, this.formattedChartData)))
          );
        }

        this.drawnChart.canvas.parentNode.style.height = (this.proceedingsByTopics.length * 20 + 40) + "px";
        this.drawnChart.options.plugins.tooltip.filter = function (context) {
          return context.dataset.showThisTooltip;
        };
        this.drawnChart.update("none");
      }
    },
    setDisplayType (type) {
      this.displayType = type;
    },
    translate (tid) {
      return this.$t(tid);
    }
  }
};
</script>

<template>
  <section class="ProceedingStatisticsProceedingsByTopics">
    <h3>
      {{ $t("components.ProceedingStatisticsProceedingsByTopics.headline") }}
    </h3>

    <div
      v-show="displayType === 'charts'"
      class="canvasContainer"
    >
      <canvas
        ref="chart"
        :alt="translate('components.ProceedingStatisticsProceedingsByTopics.altTextCanvas')"
      />
    </div>

    <table v-show="displayType === 'tables'">
      <thead>
        <tr>
          <th id="topicname">
            {{ $t("components.ProceedingStatisticsProceedingsByTopics.tableHead.columnTopic") }}
          </th>
          <th id="topiccount">
            {{ $t("components.ProceedingStatisticsProceedingsByTopics.tableHead.columnCount") }}
          </th>
          <th id="topicpercent">
            {{ $t("components.ProceedingStatisticsProceedingsByTopics.tableHead.columnPercentage") }}
          </th>
        </tr>
      </thead>
      <tbody>
        <tr
          v-for="data in proceedingsByTopics"
          :key="'row-' + data.topic"
        >
          <td headers="topicname">
            {{ data.topic }}
          </td>
          <td headers="topiccount">
            {{ data.count }}
          </td>
          <td headers="topicpercent">
            {{ data.percentage }}%
          </td>
        </tr>
      </tbody>
    </table>
  </section>
</template>

<style lang="scss">
@import "../../../scss/_global.scss";

section.ProceedingStatisticsProceedingsByTopics {
  div.canvasContainer {
    position: relative;
  }
}
</style>
